********************************************************************************
*			DEFINITIONS HERE				       *
********************************************************************************

crtaddr 	equ	$E600		* 6845
crtdata 	equ	$E601

piadra		equ	$E628		* 6821
piadrb		equ	$E629
piacra		equ	$E62A
piacrb		equ	$E62B

acia_baud	equ	$E645
		* 6850
acia_control	equ	$E646
acia_data	equ	$E647

key_timer0	equ	$ED09
key_timer1	equ	$ED0A
key_timer2	equ	$ED0B
kbd_store	equ	$ED0C
kbd_load	equ	$ED0E
old_key 	equ	$ED31		;
kbd_temp	equ	$ED50
kbd_buffer	equ	$BFF0
kbd_buffer_end	equ	$C000

_CAPS_LOCK	equ	$FC

COPY		equ	1
DRAW_CHAR	equ	2
DRAW_LINE	equ	3
CLEAR_SCREEN	equ	4
WINDOW_SIZE	equ	5
PUT_CURSOR	equ	6
UNPUT_CURSOR	equ	7
NEW_CURSOR	equ	8
READ_KEYCODE	equ	10

SCRWIDTH	equ	51
SCRHEIGHT	equ	25

	org	$100
	
	jmp	start
********************************************************************************
*			Serial IO ணࠬ				       *
********************************************************************************
*
* 祭   SIO
*
sio_read
	ldab	#%00000001
sio_r1	bitb	acia_control	*   襭 ਥ
	beq	sio_r1
	ldaa	acia_data	* ⠥
	rts

*
* 뢮   SIO
*	
sio_write
	ldab	#%00000010
sio_w1	bitb	acia_control	*    ।
	bne	sio_w1
	staa	acia_data	* ।
	rts

*
* 樠 SIO
*
initSio
	ldab	#%00000011	*  SIO
	stab	acia_control	*

	ldab	#%00000111	* ⠭ ᪮ 19200
	stab	acia_baud	*  ॣ ⥫  뫤
	ldab	#%01010001	* 8 bit, 2 stop, 1:16f
	stab	acia_control	*  SIO
	rts

********************************************************************************
*			୮ 뢠 int $09			       *
********************************************************************************
int09
	tst	key_timer0	* ஢ઠ  ॡ 
	beq	i09ok
	ldaa	piadra
i09ret	rts
i09ok	clrb
i09loop	ldaa	piadra
	decb
	beq	i09ret
	cmpa	#$ff
	beq	i09loop		* ய᪠ ⮥ ⥭
	ldab	#30
	cmpa	old_key
	bne	i09dif

	tst	key_timer1
	bne	i09ret1
	
	ldab	#3
i09dif	stab	key_timer1
	staa	old_key
	ldx	kbd_store
	inx
	cpx	#kbd_buffer_end
	bne	i09s1
	ldx	#kbd_buffer
i09s1	stx	kbd_temp	; new kbd_store
	cpx	kbd_load	; buffer full ?
	beq	i09ret1		; yes

	ldab	piacra
	cmpa	#_CAPS_LOCK
	bne	not_caps_lock
	eorb	#8		;  ᢥ⮤
	stab	piacra
not_caps_lock
	ldx	kbd_store	; ࠭塞 ⠭  
	staa	0,x
	ldx	kbd_temp
	stx	kbd_store
	bsr	soundkey
i09ret1
	ldab	#3
	stab	key_timer0
	ldab	#5
	stab	key_timer2
	rts

soundkey
	ldaa	#15
soundkey0
	ldab	piacrb
	eorb	#8
	stab	piacrb
	ldab	key_timer1
soundkey1
	decb
	nop
	bne	soundkey1
	ldab	piacrb
	eorb	#8
	stab	piacrb
	ldab	key_timer1
soundkey2
	incb
	cmpb	#60
	bne	soundkey2
	deca
	bne	soundkey0
	rts
	
********************************************************************************
*			⢥ ᠬ ணࠬ			       *
********************************************************************************
start
	ldaa	#$09		*   ࠡ稪 뢠
	clrb			* 
	ldx	#int09		*
	int	$2f		*
	
	jsr	initSio		* 樠 RS232
	jsr	initScr53	* 樠 ࠭ ਭ 53 ᨬ
	jsr	cclearscreen	* ⪠ ࠭
	ldx	#logo1
	ldaa	#10
	ldab	#3
	jsr	fastDL		* 뢮 

	ldaa	#6		* ⠭ ࠧ 
	ldab	#7		* 2  ﬨ 
	jsr	cnew_cursor1	*

mainLoop
	cli			* 뢠 ࠧ襭  ६ 
	jsr	sio_read	*   VPC ࢥ
	sei			*  뢠  ६ 믮 
	cmpa	#COPY
	bne	main1
	jsr	ccopy
	jmp	mainNext
main1	cmpa	#DRAW_CHAR
	bne	main2
	jsr	cdrawchar
	jmp	mainNext
main2	cmpa	#DRAW_LINE
	bne	main3
	jsr	cdrawline
	jmp	mainNext
main3	cmpa	#CLEAR_SCREEN
	bne	main4
	jsr	cclearscreen
	jmp	mainNext
main4	cmpa	#WINDOW_SIZE
	bne	main5
	jsr	cwindowsize
	jmp	mainNext
main5	cmpa	#READ_KEYCODE
	bne	main6
	jsr	creadkeycode
	jmp	mainNe1
main6	cmpa	#PUT_CURSOR
	bne	main7
	jsr	cputcursor
	jmp	mainNext
main7	cmpa	#UNPUT_CURSOR
	bne	main8
	jsr	cunputcursor
	jmp	mainNext
main8	cmpa	#NEW_CURSOR
	bne	main9
	jsr	cnew_cursor
	jmp	mainNext
main9
mainNext
	ldaa	#$0
mainNe1	jsr	sio_write	* 뫪 ࢥ  襭 믮
	jmp	mainLoop

*
*  ஢ ࠭
*	
tcopy	db	'COPY',0
ccopy
	jsr	sio_write	* 뫪   
	jsr	sio_read
	staa	cx
	jsr	sio_read
	staa	cy
	jsr	sio_read
	staa	cx1
	jsr	sio_read
	staa	cy1
	jsr	sio_read
	staa	nx
	jsr	sio_read
	staa	ny
	jmp	fastCP
	rts

*
*  뢮  ᨬ  ࠭
*
tdrawchar db	'DRAW_CHAR',0
cdrawchar
	jsr	sio_write	* 뫪   
	jsr	sio_read
	staa	cx
	jsr	sio_read
	staa	cy
	jsr	sio_read
	staa	char
	ldaa	cx
	ldab	cy
	jsr	calcScr53
	staa	x1+1
	stab	x1
	andb	#$0F
	orab	#$20
	staa	x2+1
	stab	x2
	ldaa	char
	ldx	x1
	staa	0,x
	ldx	x2
	staa	0,x
	rts

*
*  뢮 ப  ࠭
*
tdrawline db	'DRAW_LINE',0
cdrawline
	jsr	sio_write	* 뫪   
	jsr	sio_read
	staa	cx
	jsr	sio_read
	staa	cy
	jsr	sio_read
	staa	nx
	jsr	sio_read
	staa	nx+1
	ldx	#buffer
	stx	ny
	ldx	nx
cdrawl1	stx	nx
	ldx	ny
	jsr	sio_read
	staa	0,x
	inx
	stx	ny
	ldx	nx
	dex
	bne	cdrawl1
	ldx	ny
	clr	0,x
	ldx	#buffer
	ldaa	cx
	ldab	cy
	jmp	fastDL

*
*  ⪨ ࠭
*
tcls	db	'CLEAR_SCREEN',0
cclearscreen
	ldx	#$2000
	stx	x1
	ldx	#$F000
	stx	x2
	ldaa	#26
cclear1	ldab	#SCRWIDTH+2
cclear2 ldx	x1
	clr	0,x
	inx
	stx	x1
	ldx	x2
	clr	0,x
	inx
	stx	x2
	decb
	bne	cclear2
	deca
	bne	cclear1
	rts

*
*   ࠧ ࠭
*
twinsize db	'WINDOW_SIZE',0
cwindowsize
	jsr	sio_write	* 뫪   
	jsr	sio_read
	staa	cx
	jsr	sio_read
	staa	cy
	jsr	cclearscreen
	rts
	
logo1	db	'VirtualPC terminal version 1.0',0
logo2	db	$d6,' Sasha Chukov (sash@tspu.edu.ru), 2000',0

*
* 뢮 ப  न⠬ x, y
* A=x, B=y, X= ப
*
fastDL
	stx	tempx
	jsr	calcScr53
	staa	x1+1
	stab	x1
	andb	#$0F
	orab	#$20
	staa	x2+1
	stab	x2
	ldab	cx
	sts	sp
	ldx	tempx
	txs
fastDL1	pula
	tsta
	beq	fastDL2
	cmpb	#SCRWIDTH+1
	bcc	fastDL3
	ldx	x1
	staa	0,x
	inx
	stx	x1
	ldx	x2
	staa	0,x
	inx
	stx	x2
fastDL3	incb
	bra	fastDL1
fastDL2	lds	sp
	rts
*
* ஢   ࠭ (cx,cy)-(cx1,cy1)  (nx,ny)
*
fastCP
	ldaa	cx1
	cmpa	#SCRWIDTH
	bcs	fastCP5
	ldaa	#SCRWIDTH-1
fastCP5	suba	cx
	inca
	staa	cx1
	
	ldaa	cy1
	suba	cy
	inca
	staa	cy1

	ldaa	cx
	ldab	cy
	jsr	calcScr53
	staa	x1+1
	stab	x1
	andb	#$0F
	orab	#$20
	staa	x2+1
	stab	x2

	ldaa	nx
	ldab	ny
	jsr	calcScr53
	staa	x3+1
	stab	x3
	andb	#$0F
	orab	#$20
	staa	x4+1
	stab	x4
	sts	sp

fastCP0	ldab	cx1
	ldx	x3
	stx	dsts
	ldx	x4
	stx	dstb
	lds	x2
	des
fastCP1	pula
	ldx	dsts
	staa	0,x
	inx
	stx	dsts
	ldx	dstb
	staa	0,x
	inx
	stx	dstb
	decb
	bne	fastCP1
	ldaa	x2+1
	ldab	x2
	adda	#SCRWIDTH+2
	adcb	#0
	staa	x2+1
	stab	x2
	ldaa	x3+1
	ldab	x3
	adda	#SCRWIDTH+2
	adcb	#0
	staa	x3+1
	stab	x3
	andb	#$0F
	orab	#$20
	staa	x4+1
	stab	x4
	dec	cy1
	bne	fastCP0
	lds	sp
	rts
*
* ᬥ饭 砫 ப  ࠭  ० 42 ᨬ  ப
*		
scanlin42
	dw	$f000, $f02a, $f054, $f07e, $f0a8, $f0d2, $f0fc, $f126, $f150, $f17a
	dw	$f1a4, $f1ce, $f1f8, $f222, $f24c, $f276, $f2a0, $f2ca, $f2f4, $f31e
        dw	$f348, $f372, $f39c, $f3c6, $f3f0, $f41a, $f444, $f46e, $f498, $f4c2
*
* ᬥ饭 砫 ப  ࠭  ० 53 ᨬ  ப
*		
scanlin53
        dw	$f000, $f035, $f06a, $f09f, $f0d4, $f109, $f13e, $f173, $f1a8, $f1dd
        dw	$f212, $f247, $f27c, $f2b1, $f2e6, $f31b, $f350, $f385, $f3ba, $f3ef
        dw	$f424, $f459, $f48e, $f4c3, $f4f8, $f52d, $f562, $f597, $f5cc, $f601
*
* 樠 ० 42 ᨬ  ப
*
initScr42
	ldx	#$012a
	stx	$e600
	ldx	#$022a
	stx	$e600
	rts
*
* 樠 ० 53 ᨬ  ப
*
initScr53
	ldx	#$0135
	stx	$e600
	ldx	#$0235
	stx	$e600
	rts
*
* ᫥  ࠭  42 ᨬ  ப
* A=x, B=y
* 頥 BA=
*
calcScr42
	psha
	tba
	clrb
	asla
	adda	#scanlin42
	adcb	#scanlin42/256
	staa	$81
	stab	$80
	ldx	$80
	pula
	ldab	0,x
	adda	1,x
	adcb	#0
	rts
*
* ᫥  ࠭  53 ᨬ  ப
* A=x, B=y
* 頥 BA=
*
calcScr53
	psha
	tba
	clrb
	asla
	adda	#scanlin53
	adcb	#scanlin53/256
	staa	$81
	stab	$80
	ldx	$80
	pula
	ldab	0,x
	adda	1,x
	adcb	#0
	rts

*
*  ⥭  
*
treadkeycode db	'READ_KEYCODE',0	
creadkeycode
	ldaa	#$ff
	ldx	kbd_load
	cpx	kbd_store
	beq	creadk1
	ldaa	0,x
	inx
	cpx	#kbd_buffer_end
	bne	creadk0
	ldx	#kbd_buffer
creadk0	stx	kbd_load
creadk1	rts

*
*   ࠧ 
*
	db	'NEW_CURSOR',0
cnew_cursor
	jsr	sio_write	* 뫪   
	jsr	sio_read
	staa	cx
	jsr	sio_read
*	staa	cy
	tab
	ldaa	cx
cnew_cursor1
	psha
	tba
	ldab	#$0b
	bsr	cputc1
	decb
	pula
	bra	cputc1

*
*  뢮 
*
tputcursor db	'PUT_CURSOR',0
cputcursor
	jsr	sio_write	* 뫪   
	jsr	sio_read
	staa	cx
	jsr	sio_read
*	staa	cy
	tab
	ldaa	cx
	jsr	calcScr53
	adda	#2		* ࠢ塞   ꫤ
	adcb	#0		*
	psha
	tba
	ldab	#$0e
	bsr	cputc1
	incb
	pula
cputc1	stab	crtaddr
	staa	crtdata
	rts

*
*  襭 
*
	db	'UNPUT_CURSOR',0
cunputcursor
	ldab	#$0e
	ldaa	#$e0
	bra	cputc1

********************************************************************************
*			  			       *
********************************************************************************
		
cx	dw	0
cy	dw	0
cx1	dw	0
cy1	dw	0
nx	dw	0
ny	dw	0
char	db	0

x1	dw	0
x2	dw	0
x3	dw	0
x4	dw	0
sp	dw	0
curX	dw	0
dsts	dw	0
dstb	dw	0
tempx	dw	0

buffer	ds 128,0
